summaryrefslogtreecommitdiff
path: root/tests/rm/r-3
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rm/r-3')
-rwxr-xr-xtests/rm/r-365
1 files changed, 65 insertions, 0 deletions
diff --git a/tests/rm/r-3 b/tests/rm/r-3
new file mode 100755
index 0000000..0d85f64
--- /dev/null
+++ b/tests/rm/r-3
@@ -0,0 +1,65 @@
+#!/bin/sh
+# Create and remove a directory with more than 254 files.
+
+# Copyright (C) 1997, 2001, 2002, 2003, 2004, 2006 Free Software Foundation,
+# Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+
+# An early version of my rewritten rm failed to remove all of
+# the files on SunOS4 when there were 254 or more in a directory.
+
+# And the rm from coreutils-5.0 exposes the same problem when there
+# are 338 or more files in a directory on a Darwin-6.5 system
+
+if test "$VERBOSE" = yes; then
+ rm --version
+ set -x
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp;tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_fail=0
+mkdir -p $tmp || framework_fail=1
+cd $tmp || framework_fail=1
+
+# Create 500 files (20 * 25).
+for i in 0 1 2 3 4 5 6 7 8 9 a b c d e f g h i j; do
+ files=
+ for j in a b c d e f g h i j k l m n o p q r s t u v w x y; do
+ files="$files $i$j"
+ done
+ touch $files || framework_fail=1
+done
+
+test -f 0a || framework_fail=1
+test -f by || framework_fail=1
+cd "$pwd" || framework_fail=1
+
+if test $framework_fail = 1; then
+ echo 'failure in testing framework'
+ (exit 1); exit 1
+fi
+
+fail=0
+rm -rf $tmp || fail=1
+test -d $tmp && fail=1
+
+(exit $fail); exit $fail